<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>

    <script src="../lib/MusicalMap.js"></script>

  </head>
  <body>

    <script>

    suite('MusicalMap', () => {

      setup (() => {
        this.map = new MusicalMap()
        this.map.positions = [
          { onset : 0, x : 0},
          { onset : 1, x : 10},
          { onset : 2, x : 20},
          { onset : 3, x : 30},
          { onset : 4, x : 40}
        ]
        this.map.lastOffset = 5
      })

      suite ('-> toMusicalOnset', () => {

        test ('should work with nominal case', () => {
          assert.equal(this.map.toMusicalOnset(20), 2)
        })

        test ('should return first onset if x is negative', () => {
          assert.equal(this.map.toMusicalOnset(-10), 0)
        })

        test ('should return last onset if x is higher than the last position', () => {
          assert.equal(this.map.toMusicalOnset(50), 4)
        })

        test ('should return non matching note onset if x does not match a position (no rounding)', () => {
          assert.equal(this.map.toMusicalOnset(12), 1.2)
        })

        test ('should return non matching note onset if x (with 1 digit) does not match a position (no rounding)', () => {
          assert.equal(this.map.toMusicalOnset(12.3), 1.23)
        })

        test ('should return non matching note onset if x (with 2 digits) does not match a position (default rounding)', () => {
          assert.equal(this.map.toMusicalOnset(12.34), 1.23)
        })

        test ('should return non matching note onset if x (with 2 digits) does not match a position (excess rounding)', () => {
          assert.equal(this.map.toMusicalOnset(12.37), 1.24)
        })

        test ('should return non matching note onset if x (with 2 digits) does not match a position (default rounding) (xx.x5)', () => {
          assert.equal(this.map.toMusicalOnset(12.35), 1.23)
        })

      })

      suite ('-> previousOnset', () => {

        test ('should work with nominal case', () => {
          assert.equal(this.map.previousOnset(2), 1)
        })

        test ('should return 0 if input 0', () => {
          assert.equal(this.map.previousOnset(0), 0)
        })

        test ('should return 0 if input is negative', () => {
          assert.equal(this.map.previousOnset(-1), 0)
        })

        test ('should return last onset if input is higher than the last onset', () => {
          assert.equal(this.map.previousOnset(5), 4)
        })

        test ('should work even if onset does not match any note', () => {
          assert.equal(this.map.previousOnset(1.5), 1)
        })

        test ('should work even if onset does not match any note (min)', () => {
          assert.equal(this.map.previousOnset(1.01), 1)
        })

        test ('should work even if onset does not match any note (max)', () => {
          assert.equal(this.map.previousOnset(1.99), 1)
        })

      })

      suite ('-> offset', () => {

        test ('should work with nominal case', () => {
          assert.equal(this.map.offset(2), 3)
        })

        test ('should return last offset if input onset is last onset', () => {
          assert.equal(this.map.offset(4), 5)
        })

        test ('should return last offset if input onset is higher than last onset', () => {
          assert.equal(this.map.offset(5), 5)
        })

        test ('should return offset of first note if input onset is negative', () => {
          assert.equal(this.map.offset(-1), 1)
        })

        test ('should return offset of the previous note if input does not match any note', () => {
          assert.equal(this.map.offset(1.5), 2)
        })

        test ('should return offset of the previous note if input does not match any note (min)', () => {
          assert.equal(this.map.offset(1.01), 2)
        })

        test ('should return offset of the previous note if input does not match any note (max)', () => {
          assert.equal(this.map.offset(1.99), 2)
        })

      })

      suite ('-> toMusicalDuration (IOI)', () => {

        test ('should work with nominal case', () => {
          assert.equal(this.map.toMusicalDuration(10,20), 2)
        })

        test ('should return the max duration from start if start + length is higher than last onset', () => {
          assert.equal(this.map.toMusicalDuration(10,100), 3)
        })

        test ('should return the duration from first onset if input start is negative', () => {
          assert.equal(this.map.toMusicalDuration(-10,20), 1)
        })

        test ('should return undefined if input length is negative', () => {
          assert.equal(this.map.toMusicalDuration(10,-10), undefined)
        })

        test ('should return the piece duration if start is negative and length is higher than piece length', () => {
          assert.equal(this.map.toMusicalDuration(-10,100), 4)
        })

        test ('should work if start does not match with a note', () => {
          assert.equal(this.map.toMusicalDuration(15,15), 1.5)
        })

        test ('should work if start + length does not match with a note', () => {
          assert.equal(this.map.toMusicalDuration(10,15), 1.5)
        })

        test ('should work if start and start + length does not match with a note ', () => {
          assert.equal(this.map.toMusicalDuration(15,20), 2)
        })

        test ('should work if start and start + length define a segment between 2 notes', () => {
          assert.equal(this.map.toMusicalDuration(12,5), 0.5)
        })

        test ('should return (last offset - first note offset) if the label finishes at the last note', () => {
          assert.equal(this.map.toMusicalDuration(20,20), 2)
        })

      })

      suite ('-> toMusicalDuration (Duration)', () => {

        test ('should work with nominal case', () => {
          assert.equal(this.map.toMusicalDuration(10,20,false), 3)
        })

        test ('should return the max duration from start if start + length is higher than last onset', () => {
          assert.equal(this.map.toMusicalDuration(10,100, false), 4)
        })

        test ('should return the duration from first onset if input start is negative', () => {
          assert.equal(this.map.toMusicalDuration(-10,20, false), 2)
        })

        test ('should return the piece duration if start is negative and length is higher than piece length', () => {
          assert.equal(this.map.toMusicalDuration(-10,100, false), 5)
        })

        test ('should work if start does not match with a note', () => {
          assert.equal(this.map.toMusicalDuration(15,15,false), 2.5)
        })

        test ('should work if start + length does not match with a note', () => {
          assert.equal(this.map.toMusicalDuration(10,15,false), 2)
        })

        test ('should work if start and start + length does not match with a note ', () => {
          assert.equal(this.map.toMusicalDuration(15,20,false), 2.5)
        })

        test ('should return duration of the previous note - (onset of start - onset of previous note) if start and start + length define a segment between 2 notes', () => {
          assert.equal(this.map.toMusicalDuration(12,5,false), 0.8)
        })

      })

      suite ('-> toGraphicalX', () => {

        test ('should work with nominal case', () => {
          assert.equal(this.map.toGraphicalX(2), 20)
        })

        test ('should return first position if onset is negative', () => {
          assert.equal(this.map.toGraphicalX(-1), 0)
        })

        test ('should return last position if onset is higher than the last onset', () => {
          assert.equal(this.map.toGraphicalX(5), 40)
        })

        test ('should return non matching note position if onset (with 1 digit) does not match a note (no rounding)', () => {
          assert.equal(this.map.toGraphicalX(1.2), 12)
        })

        test ('should return non matching note position if onset (with 2 digits) does not match a note (no rounding)', () => {
          assert.equal(this.map.toGraphicalX(1.23), 12.3)
        })

        test ('should return non matching note position if onset (with 3 digits) does not match a note (no rounding)', () => {
          assert.equal(this.map.toGraphicalX(1.234), 12.34)
        })

        test ('should return non matching note position if onset (with 4 digits) does not match a note (excess rounding) (xx.xxx5)', () => {
          assert.equal(this.map.toGraphicalX(1.2345), 12.35)
        })

        test ('should return non matching note position if onset (with 4 digits) does not match a note (excess rounding)', () => {
          assert.equal(this.map.toGraphicalX(1.2347), 12.35)
        })

        test ('should return non matching note position if onset (with 4 digits) does not match a note (default rounding)', () => {
          assert.equal(this.map.toGraphicalX(1.2342), 12.34)
        })

      })

      suite ('-> toGraphicalLength (IOI)', () => {

        test ('should work with nominal case', () => {
          assert.equal(this.map.toGraphicalLength(1,2), 20)
        })

        test ('should return the max length from onset if onset + duration is higher than last position', () => {
          assert.equal(this.map.toGraphicalLength(1,4), 30)
        })

        test ('should return the length from first position if input onset is negative', () => {
          assert.equal(this.map.toGraphicalLength(-1,2), 10)
        })

        test ('should return undefined if input duration is negative', () => {
          assert.equal(this.map.toGraphicalLength(1,-1), undefined)
        })

        test ('should return the total image length (first bar to last one) if onset is negative and duration is higher than piece duration', () => {
          assert.equal(this.map.toGraphicalLength(-1,10), 40)
        })

        test ('should work if onset does not match with a note', () => {
          assert.equal(this.map.toGraphicalLength(1.5,1.5), 15)
        })

        test ('should work if onset + duration does not match with a note', () => {
          assert.equal(this.map.toGraphicalLength(1,1.5), 15)
        })

        test ('should work if onset and onset + duration does not match with a note ', () => {
          assert.equal(this.map.toGraphicalLength(1.5,2), 20)
        })

        test ('should work if onset and onset + duration define a segment between 2 notes', () => {
          assert.equal(this.map.toGraphicalLength(1.2,0.5), 5)
        })

      })

      suite ('-> toGraphicalLength (Duration)', () => {

        test ('should work with nominal case', () => {
          assert.equal(this.map.toGraphicalLength(1,2,false), 10)
        })

        test ('should return the max length from onset if onset + duration is higher than last position', () => {
          assert.equal(this.map.toGraphicalLength(1,4, false), 30)
        })

        test ('should return the length from first position if input onset is negative', () => {
          assert.equal(this.map.toGraphicalLength(-1,2, false), 0)
        })

        test ('should return the total image length (first bar to last one) if onset is negative and duration is higher than piece duration', () => {
          assert.equal(this.map.toGraphicalLength(-1,10, false), 40)
        })

        test ('should work if onset does not match with a note', () => {
          assert.equal(this.map.toGraphicalLength(1.5,1.5,false), 5)
        })

        test ('should work if onset and onset + duration does not match with a note', () => {
          assert.equal(this.map.toGraphicalLength(1,1.5,false), 10)
        })

        test ('should work if onset and onset + duration define a segment between 2 notes', () => {
          assert.equal(this.map.toGraphicalLength(1.5,2,false), 15)
        })

        test ('should return duration of the previous note - (onset of start - onset of previous note) if start and start + length define a segment between 2 notes', () => {
          assert.equal(this.map.toGraphicalLength(1.2,0.5,false), 0)
        })

      })

    });

    </script>

  </body>
</html>
